
//CAMERA:
//#define cameratrigger 2 // A2 x D2
//#define camerafocus 3 // A3 x D3
#define cameratrigger A2 // MODIFICADO HW
#define camerafocus A3 // MODIFICADO HW
#define ledPin 13

// DISPLAY:
// defines pins numbers, A,B,C y D=valor Hex / a,b,c= Bin (Display 1,2,3.. a 8) Con 74155N.
// pin d , blanking display
#define A_Pin 9
#define B_Pin 10
#define C_Pin 12
#define D_Pin 11
#define a_Pin A5 // a,b,c => Strobe Display 1 a 8
#define b_Pin A4 // Strobe low Dato -> Lacht (directo)
#define c_Pin 7  // Strobe High Dato -x-> Lacht (memoria)
#define d_Pin 8 // Blanking Display 1=off

//ENCODER:
#include "Encoder.h"
const bool pullup = true;
//Encoder rotary(A3, A2, A1); // A2,A3 x D2,D3
Encoder rotary(3, 2, A1); // MODIFICADO HW
long prevCount = 0;
// Switch 1: (Mode button)
#define SW1_Pin A0
int buttonPushCounter = 0;
int buttonState = 0;
int lastButtonState = 0;
int contador = 0;

//STEP-MOTOR:
#include "AccelStepper.h"
#define stepPin 6
#define dirPin 5
#define enPin 4
#define motorInterfaceType 1
#define stepsPerRevolution 5 // Pasos por vuelta ->Modo_Pos()

AccelStepper stepper(motorInterfaceType, stepPin, dirPin);
//AccelStepper stepper; // Defaults to AccelStepper::FULL4WIRE (4 pins) on 2, 3, 4, 5
/*
  AccelStepper::AccelStepper  (   uint8_t   interface = AccelStepper::FULL4WIRE,
    uint8_t   pin1 = 2,
    uint8_t   pin2 = 3,
    uint8_t   pin3 = 4,
    uint8_t   pin4 = 5,
    bool    enable = true
  )
  [in] pin1  Arduino digital pin number for motor pin 1. Defaults to pin 2.
  For a AccelStepper::DRIVER (interface==1), this is the Step input to the driver. Low to high transition means to step)
  [in] pin2  Arduino digital pin number for motor pin 2. Defaults to pin 3.
  For a AccelStepper::DRIVER (interface==1), this is the Direction input the driver. High means forward.
  [in]  enable  If this is true (the default),
  enableOutputs() will be called to enable the output pins at construction time.
*/
// setEnablePin()

//TECLAS:
int adc_key_in  = 0;
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5
// read_buttons()  // para leer los botones

// Parameters:
int unidad = 0 ; // Para display
int decena = 0 ; // Para display
int centena = 0 ; // Para display
int pasos =  0;
int recorrido = 270; // 270 Recorrido completo
// 150 pasos = 22,5mm // precision del paso 0,159mm // zona util 40mm aprox , 250 pasos
int velocidad = 300; // Impulsos al motor 280-320
int retardo = 1000; // tiempo en milisegundos entre pasos
int t_expo = 300; // tiempo en milisegundos del disparo -> Disparo()
int fotos = 0;
int motor = 0; // contador del motor
int Pos1 = 0; // posicion1 del motor
int Pos2 = 0; // posicion2 del motor
int posicion = 0; //Posicion actual del motor
long y = 0; // Incremento paso
unsigned long time = millis();
unsigned long timepassed;

int modo_old = 0;
int pos1_old = 0;
int pos2_old = 0;
int pos_old = 0;
int pasos_old = 0;
int retardo_old = retardo;

void setup()
{
  Serial.begin(9600);
  //pinMode(SW1_Pin, INPUT_PULLUP);
  pinMode(SW1_Pin, INPUT);
  // Sets the pins as Outputs Display
  pinMode(A_Pin, OUTPUT);
  pinMode(B_Pin, OUTPUT);
  pinMode(C_Pin, OUTPUT);
  pinMode(D_Pin, OUTPUT);
  pinMode(a_Pin, OUTPUT);
  pinMode(b_Pin, OUTPUT);
  pinMode(c_Pin, OUTPUT);
  pinMode(d_Pin, OUTPUT);
  digitalWrite(a_Pin, LOW);
  digitalWrite(b_Pin, LOW);
  digitalWrite(c_Pin, LOW);
  digitalWrite(d_Pin, LOW);

  // Camera Outputs
  pinMode(ledPin, OUTPUT);
  pinMode(camerafocus, OUTPUT);
  pinMode(cameratrigger, OUTPUT);

  // Sets the two pins as Outputs for step-motor
  pinMode(stepPin, OUTPUT);
  pinMode(dirPin, OUTPUT);
  pinMode(enPin, OUTPUT);
  digitalWrite(enPin, HIGH);
  // Set the maximum speed in steps per second: (1000 Max)
  stepper.setMaxSpeed(1000);
  // Here you could put a homing sequence:
  stepper.setCurrentPosition(0);
  Serial.println (" ");
  Serial.println(" TEST: ");
  prueba(); // Prueba digitos
  Centena (centena);
  Decena (decena);
  Unidad (unidad);
  Modo (contador);
}

//++++++++++++++++++++++++BUCLE PRINCIPAL++++++++++++++++++++++++
void loop()
{
  // Comprueba modo con el pulsador key right
  Check_button();
  //Serial.print(" Number of button pushes: ");
  //Serial.print(buttonPushCounter);
  Modo (contador);
  switch (contador) {
    case 1:
      // statements
      //Serial.print(" Posicionamiento 1 ");
      Modo_Pos (); // LLAMADA A SUBRUTINA Pos1
      break;
    case 2:
      // statements
      //Serial.print(" Posicionamiento 2 ");
      Modo_Pos (); // LLAMADA A SUBRUTINA Pos 2
      break;
    case 3:
      // statements
      //Serial.print(" Volver Pos 1  ");
      Modo_Volver ();
      break;
    case 4:
      // statements
      //Serial.print(" Secuencia Prueba  ");
      Modo_Av_Motor ();
      break;
    case 5:
      // statements
      //Serial.print(" Secuencia Disparo ");
      Modo_Av_Motor ();
      break;
    case 6:
      // statements
      //Serial.print(" Ajuste retardo "); //tiempo entre pasos
      Modo_Ajuste ();
      break;
    case 7:
      // statements
      Serial.println(" Pruebas de codigo ");
      if (rotary.check(HIGH))
      {
        Prueba_Cod ();
        contador = 0;
      }
      break;
    default:
      // statements MODO=0
      //Serial.print(" Reposo ");
      if (rotary.check(HIGH))// Si pulsamos encoder se restean todos los valores
      {
        Serial.println(" Poner a 0....");
        delay(1000);
        digitalWrite(enPin, LOW);
        while (stepper.currentPosition() != 0)
        {
          stepper.setSpeed(-200);
          //stepper.runSpeed();
          stepper.run();
        }
        digitalWrite(enPin, HIGH);
        stepper.setCurrentPosition(0);
        posicion = 0;
        Pos1 = 0;
        Pos2 = 0;
        pasos = 0;

      }
      Posicion (); //actualizar posicion en display y terminal
      break;
  }
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void Check_button() {
  //buttonState = digitalRead(SW1_Pin);
  buttonState = read_buttons();
  if (buttonState != lastButtonState)
  {
    if ((buttonState == 1) && (contador == 1 || contador == 2)) // UP
    {
      if (posicion < recorrido)
      {
        buttonPushCounter++;
        posicion++;
        digitalWrite(enPin, LOW);
        digitalWrite(dirPin, HIGH); // Enables the motor to move in a particular direction
        digitalWrite(stepPin, HIGH);
        delayMicroseconds(velocidad);
        digitalWrite(stepPin, LOW);
        delayMicroseconds(velocidad);
        digitalWrite(enPin, HIGH);
        stepper.setCurrentPosition(posicion);
        delay(100); //500
      }
    }
    else if ((buttonState == 2)  && (contador == 1 || contador == 2)) // DOWN
    {
      if (posicion > 0)
      {
        buttonPushCounter++;
        posicion--;
        digitalWrite(enPin, LOW);
        digitalWrite(dirPin, LOW); // Enables the motor to move in a particular direction
        digitalWrite(stepPin, HIGH);
        delayMicroseconds(velocidad);
        digitalWrite(stepPin, LOW);
        delayMicroseconds(velocidad);
        digitalWrite(enPin, HIGH);
        stepper.setCurrentPosition(posicion);
        digitalWrite(dirPin, HIGH); // Restauramos valor
        delay(100); //500
      }
    }
    else if ((buttonState == 0) && (contador == 1 || contador == 2)) // RIGHT
    {
      if (posicion < (recorrido - 10))
      {
        buttonPushCounter++;
        motor = motor + 10;
        delay(100); //500
      }
      digitalWrite(enPin, LOW);
      while (stepper.currentPosition() != motor)
      {
        stepper.setSpeed(200);
        //stepper.runSpeed();
        stepper.run();
      }
      digitalWrite(enPin, HIGH);
    }
    else if ((buttonState == 3) && (contador == 1 || contador == 2)) // LEFT
    {
      if (posicion > 10)
      {
        buttonPushCounter++;
        motor = motor - 10;
        delay(100); //500
      }
      digitalWrite(enPin, LOW);
      while (stepper.currentPosition() != motor)
      {
        stepper.setSpeed(-200);
        //stepper.runSpeed();
        stepper.run();
      }
      digitalWrite(enPin, HIGH);
    }
    else if (buttonState == 4) // Select
    {
      buttonPushCounter++;
      contador++;
      delay(100); //500
    }
  }
  lastButtonState = buttonState;
  if (contador >= 7)
  {
    contador = 0;
    Serial.print("Resultado Final = ");
    Serial.println(buttonPushCounter);
    buttonPushCounter = 0;
  }
  //Serial.print("Boton = ");
  //Serial.println(buttonState);
}

void Posicion () {
  pasos = Pos2 - Pos1;
  posicion = stepper.currentPosition();
  timepassed = millis();
  if ((timepassed - time > 5000) && ((contador == 0) || (contador == 3))) {
    Modo (15);
    centena = pasos / 100;
    Centena (centena); // Display Centenas
    decena = (pasos - (centena * 100)) / 10;
    Decena (decena); // Display Decenas
    unidad = pasos - ((centena * 100) + (decena * 10));
    Unidad (unidad); // Display Unidades
    time = millis();
    delay(750);
    Modo (contador);
    centena = posicion / 100;
    Centena (centena); // Display Centenas
    decena = (posicion - (centena * 100)) / 10;
    Decena (decena); // Display Decenas
    unidad = posicion - ((centena * 100) + (decena * 10));
    Unidad (unidad); // Display Unidades
  }
  else {
    if ((modo_old != contador)
        || (pos1_old != Pos1)
        || (pos2_old != Pos2)
        || (pos_old != posicion)
        || (pasos_old != pasos))
    {
      Serial.print("Modo:");
      Serial.print(contador);
      Serial.print(" Pos1:");
      Serial.print(Pos1);
      Serial.print(" Pos2:");
      Serial.print(Pos2);
      Serial.print(" Posicion:");
      Serial.print(posicion);
      Serial.print(" Pasos:");
      Serial.print(pasos);
      Serial.println (" ");
      modo_old = contador;
      pos1_old = Pos1;
      pos2_old = Pos2;
      pos_old = posicion;
      pasos_old = pasos;
      Modo (contador);
      centena = posicion / 100;
      Centena (centena); // Display Centenas
      decena = (posicion - (centena * 100)) / 10;
      Decena (decena); // Display Decenas
      unidad = posicion - ((centena * 100) + (decena * 10));
      Unidad (unidad); // Display Unidades
    }
  }
  /*
    Serial.print(" timepassed:");
    Serial.print(timepassed);
    Serial.print(" time:");
    Serial.print(time);
  */
  return;
}

// ***************MODOS***************

void Modo_Pos() {   // Modo 1 y 2
  //Check_button();
  prevCount = rotary.readCount();
  rotary.read();
  if (prevCount < rotary.readCount())
  {
    for (int mup = 0; mup < stepsPerRevolution; mup++)
    {
      if (motor < recorrido)
      {
        motor ++;
      }
    }
    digitalWrite(enPin, LOW);
    while (stepper.currentPosition() != motor)
    {
      stepper.setSpeed(200);
      //stepper.runSpeed();
      stepper.run();
    }
    digitalWrite(enPin, HIGH);
  }
  if (prevCount > rotary.readCount())
  {
    for (int mup = 0; mup < stepsPerRevolution; mup++)
    {
      if (motor > 0)
      {
        motor --;
      }
    }
    digitalWrite(enPin, LOW);
    while (stepper.currentPosition() != motor)
    {
      stepper.setSpeed(-200);
      //stepper.runSpeed();
      stepper.run();
    }
    digitalWrite(enPin, HIGH);
  }
  if (contador == 1) {
    // lectura del sw del encoder, para fijar pos
    if (rotary.check(HIGH))
    {
      Serial.println(" Fijar Posicion 1....");
      delay (1000);
      for (int mup = 1; mup < 10; mup++)
      {
        digitalWrite(d_Pin, HIGH);
        delay(50);
        digitalWrite(d_Pin, LOW);
        delay(50);
      }
      Pos1 = motor;
      contador = 2; // fuerza avance al menu siguiente
    }
  }
  if (contador == 2)
  {
    // lectura del sw del encoder, para poner a 0
    if (rotary.check(HIGH))
    {
      if (motor > Pos1)
      {
        Serial.println(" Fijar Posicion 2...");
        delay (1000);
        for (int mup = 1; mup < 10; mup++)
        {
          digitalWrite(d_Pin, HIGH);
          delay(50);
          digitalWrite(d_Pin, LOW);
          delay(50);
        }
        Pos2 = motor;
      }
      else
      {
        Serial.println(" ¡ERROR! Pos1 < Pos2 ");
        Modo (14); // "E" en display modo
        for (int mup = 1; mup < 10; mup++)
        {
          digitalWrite(d_Pin, HIGH);
          delay(50);
          digitalWrite(d_Pin, LOW);
          delay(50);
        }
        Modo (contador);
      }
      contador = 3; // fuerza avance al menu siguiente
    }
  }
  posicion = motor;
  Posicion (); //actualizar posicion en display y terminal
}

void Modo_Volver ()   // Modo 3
{
  // lectura del sw del encoder, para volver
  if (rotary.check(HIGH) || contador > 3)
  {
    if (Pos2 > Pos1)
    {
      Serial.println("Retroceso a Pos 1...");
      digitalWrite(enPin, LOW);
      while (stepper.currentPosition() != Pos1)
      {
        stepper.setSpeed(-200);
        //stepper.runSpeed();
        stepper.run();
      }
      digitalWrite(enPin, HIGH);
    }
    else
    {
      Serial.println(" ¡ERROR! Pos1 < Pos2 ");
      Modo (14); // "E" en display modo
      for (int mup = 1; mup < 10; mup++)
      {
        digitalWrite(d_Pin, HIGH);
        delay(50);
        digitalWrite(d_Pin, LOW);
        delay(50);
      }
      Modo (contador);
    }
  }
  Posicion (); //actualizar posicion en display y terminal
}

void Modo_Av_Motor () // Modo 4 y 5
{
  int y = 0;
  // Pulsar sw del encoder, para comenzar
  if (rotary.check(HIGH))
  {
    Serial.println(" Comenzando Prueba Motor...");
    delay(1000);
    // Comprobacion posicion:
    if (posicion > Pos1)
    {
      Serial.println("Retroceso a Pos 1...");
      digitalWrite(enPin, LOW);
      while (stepper.currentPosition() != Pos1)
      {
        stepper.setSpeed(-200);
        //stepper.runSpeed();
        stepper.run();
      }
      digitalWrite(enPin, HIGH);
    }
    if (posicion < Pos1)
    {
      Serial.println("Avance a Pos 1...");
      digitalWrite(enPin, LOW);
      while (stepper.currentPosition() != Pos1)
      {
        stepper.setSpeed(200);
        //stepper.runSpeed();
        stepper.run();
      }
      digitalWrite(enPin, HIGH);
    }
    // Comienza recorrido
    Serial.println("Comienza recorrido...");
    for (int x = 0; x < (pasos); x++)
    {
      y = Pos1 + x;
      //posicion = y;
      digitalWrite(enPin, LOW);
      digitalWrite(dirPin, HIGH); // Enables the motor to move in a particular direction
      digitalWrite(stepPin, HIGH);
      delayMicroseconds(velocidad);
      digitalWrite(stepPin, LOW);
      delayMicroseconds(velocidad);
      digitalWrite(enPin, HIGH);
      stepper.setCurrentPosition(y);
      delay(retardo);
      if (rotary.check(HIGH))
      {
        while (rotary.check(HIGH));   // Wait till button release
        Serial.println(" Pausado...");
        digitalWrite(d_Pin, HIGH);
        while (!rotary.check(HIGH));  // Wait till second button press
        digitalWrite(d_Pin, LOW);
      }
      if (contador == 5) {
        Disparo();
      }
      else {
        delay(700); // equivale al delay de disparo
      }
      Posicion (); //actualizar posicion en display y terminal
    }
    Serial.println("Final carrera, inico retroceso");
    delay(1000); // One second delay
    digitalWrite(enPin, LOW);
    while (stepper.currentPosition() != Pos1)
    {
      stepper.setSpeed(-200);
      //stepper.runSpeed();
      stepper.run();
    }
    digitalWrite(enPin, HIGH);
    delay(1000); // One second delay
    Serial.println("Motor Off");
    fotos = 0;
  }
  Posicion (); //actualizar posicion en display y terminal
}

void Modo_Ajuste () // Modo 6
{
  prevCount = rotary.readCount();
  rotary.read();
  if (prevCount < rotary.readCount())
  {
    if (retardo < 9500)
    {
      retardo = retardo + 500;
    }
  }
  if (prevCount > rotary.readCount())
  {
    if (retardo >= 0)
    {
      retardo = retardo - 500;
    }
  }
  /*
    if (rotary.check(HIGH))
    {}
  */
  if (retardo_old != retardo)
  {
    Serial.print("Tiempo entre pasos:");
    Serial.print(retardo);
    Serial.println("ms: ");
    retardo_old = retardo;
  }
  Modo (10);
  centena = retardo / 1000;
  Centena (centena); // Display Centenas
  decena = (retardo - (centena * 1000)) / 100;
  Decena (decena); // Display Decenas
  unidad = retardo - ((centena * 1000) + (decena * 100));
  Unidad (unidad); // Display Unidades
  delay(200);
}

//**************Rutinas accesorias***********

void Disparo() {
  fotos ++;
  Serial.print(" FOTO :");
  Serial.print(fotos);
  Serial.print(" ");
  Modo (15);
  centena = fotos / 100;
  Centena (centena); // Display Centenas
  decena = (fotos - (centena * 100)) / 10;
  Decena (decena); // Display Decenas
  unidad = fotos - ((centena * 100) + (decena * 10));
  Unidad (unidad); // Display Unidades
  digitalWrite(ledPin, HIGH);
  digitalWrite(camerafocus, HIGH);
  delay(200); // 200 ms previos enfoque
  digitalWrite(cameratrigger, HIGH);
  delay(t_expo);
  digitalWrite(cameratrigger, LOW);
  digitalWrite(camerafocus, LOW);
  delay(500); // aseguramos 500ms entre disparos
  digitalWrite(ledPin, LOW);
}

int read_buttons()
{ adc_key_in = analogRead(0);      // Leemos A0
  //Serial.print (" Teclas:");
  //Serial.println (adc_key_in);

  /* Mis botones dan:
    Key1 RIGHT:0
    Key2 UP:89
    Key3 DOWN:241
    Key4 LEFT:443
    Key5 SELECT:652
    Y ahora los comparamos con un margen comodo
  */

  if (adc_key_in > 900) return btnNONE;     // Ningun boton pulsado
  if (adc_key_in < 50)   return btnRIGHT;
  if (adc_key_in < 150)  return btnUP;
  if (adc_key_in < 300)  return btnDOWN;
  if (adc_key_in < 550)  return btnLEFT;
  if (adc_key_in < 800)  return btnSELECT;
  return btnNONE;  // Por si todo falla

  /*
    if (adc_key_in < 50) {
    Serial.println ("Right ");
    }
    else if (adc_key_in < 150) {
    Serial.println ("Up    ");
    }
    else if (adc_key_in < 300) {
    Serial.println ("Down  ");
    }
    else if (adc_key_in < 550) {
    Serial.println ("Left  ");
    }
    else if (adc_key_in < 800) {
    Serial.println ("Select");
    }
  */
}

//********************SUBRUTINAS DE DISPLAY**********************
void Unidad(int unidad) // Imprime el valor unidad en el digito 1
{
  digitalWrite(a_Pin, HIGH);
  digitalWrite(b_Pin, HIGH);
  digitalWrite(c_Pin, HIGH);
  switch (unidad) // Usando U4 para unidad
  {
    case 0:
      //do something when var equals 0
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 1:
      //do something when var equals 1
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 2:
      //do something when var equals 2
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 3:
      //do something when var equals 3
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 4:
      //do something when var equals 4
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 5:
      //do something when var equals 5
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 6:
      //do something when var equals 6
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 7:
      //do something when var equals 7
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 8:
      //do something when var equals 8
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    case 9:
      //do something when var equals 9
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    default:
      // if nothing else matches, do the default
      // default is optional
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, HIGH);
      break;
  }
}

void Decena(int decena) // Imprime el valor decena en el digito 2
{
  digitalWrite(a_Pin, LOW);
  digitalWrite(b_Pin, HIGH);
  digitalWrite(c_Pin, HIGH);
  switch (decena) // Usando U3 para decenas
  {
    case 0:
      //do something when var equals 0
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 1:
      //do something when var equals 1
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 2:
      //do something when var equals 2
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 3:
      //do something when var equals 3
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 4:
      //do something when var equals 4
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 5:
      //do something when var equals 5
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 6:
      //do something when var equals 6
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 7:
      //do something when var equals 7
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 8:
      //do something when var equals 8
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    case 9:
      //do something when var equals 9
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    default:
      // if nothing else matches, do the default
      // default is optional
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, HIGH);
      break;
  }
}

void Centena(int centena) // Imprime el valor centena en el digito 3
{
  digitalWrite(a_Pin, HIGH);
  digitalWrite(b_Pin, LOW);
  digitalWrite(c_Pin, HIGH);
  switch (centena) // Usando U2 para Centena
  {
    case 0:
      //do something when var equals 0
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 1:
      //do something when var equals 1
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 2:
      //do something when var equals 2
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 3:
      //do something when var equals 3
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 4:
      //do something when var equals 4
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 5:
      //do something when var equals 5
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 6:
      //do something when var equals 6
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 7:
      //do something when var equals 7
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 8:
      //do something when var equals 8
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    case 9:
      //do something when var equals 9
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    default:
      // if nothing else matches, do the default
      // default is optional
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, HIGH);
      break;
  }
}

void Modo(int contador) // Imprime el valor Modo en el digito a la derecha
{
  digitalWrite(a_Pin, HIGH);
  digitalWrite(b_Pin, HIGH);
  digitalWrite(c_Pin, LOW);
  switch (contador) // Usando U8 para Modo
  {
    case 0:
      //do something when var equals 0
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 1:
      //do something when var equals 1
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 2:
      //do something when var equals 2
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 3:
      //do something when var equals 3
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, LOW);
      break;
    case 4:
      //do something when var equals 4
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 5:
      //do something when var equals 5
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 6:
      //do something when var equals 6
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 7:
      //do something when var equals 7
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, LOW);
      break;
    case 8:
      //do something when var equals 8
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    case 9:
      //do something when var equals 9
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    case 10:
      //do something when var equals A
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    case 11:
      //do something when var equals B
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, LOW);
      digitalWrite(D_Pin, HIGH);
      break;
    case 12:
      //do something when var equals C
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, HIGH);
      break;
    case 13:
      //do something when var equals D
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, LOW);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, HIGH);
      break;
    case 14:
      //do something when var equals E
      digitalWrite(A_Pin, LOW);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, HIGH);
      break;
    default:
      // if nothing else matches, do the default
      // default is F
      digitalWrite(A_Pin, HIGH);
      digitalWrite(B_Pin, HIGH);
      digitalWrite(C_Pin, HIGH);
      digitalWrite(D_Pin, HIGH);
      break;
  }
}
//************************PRUEBA INICIAL****************************
void prueba() {
  // Ejecuta la secuencia de prueba de display y motor al principo.
  for (int unidad = 0; unidad < 10; unidad++) {
    Unidad (unidad);
    Serial.print(unidad);
    delay(velocidad / 4);
  }
  for (int decena = 0; decena < 10; decena++) {
    Decena (decena);
    Serial.print(decena);
    delay(velocidad / 4);
  }
  for (int centena = 0; centena < 10; centena++) {
    Centena (centena);
    Serial.print(centena);
    delay(velocidad / 4);
  }
  for (int contador = 0; contador < 16; contador++) {
    Modo (contador);
    Serial.print(contador);
    delay(velocidad / 4);
  }
  unidad = 0 ; // Para display
  decena = 0 ; // Para display
  centena = 0 ; // Para display
  //contador = -1;
  contador = 0;
  // Prueba motor
  Serial.println(" ");
  Serial.println(" Iniciando... ");
  delay(1000);
  digitalWrite(enPin, LOW);
  // Va al final (270):
  while (stepper.currentPosition() != recorrido)
  {
    stepper.setSpeed(200);
    stepper.run();
  }
  Serial.print(" Final:");
  Serial.println(stepper.currentPosition());
  // Vuelve a (0), asi nos aseguramos empezar en pos 0:
  while (stepper.currentPosition() != 0)
  {
    stepper.setSpeed(-200);
    stepper.run();
  }
  digitalWrite(enPin, HIGH);
  Serial.println(" Iniciado ");
}

//**********************PRUEBAS CODIGO*******************

void Prueba_Cod () {
  // Prueba motor . Overshoot.pde
  Serial.println(" ");
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  delay(1000);
  Serial.println(" Inicio Pba... ");
  digitalWrite(enPin, LOW);
  // Activamos...
  //
  int x3 = 0;
  for (int x1 = 28; x1 < 31 ; x1++)
  {
    x3 = x1 * 10;
    Serial.print("Velocidad: ");
    Serial.println(x3);
    for (int x2 = 0; x2 < 100; x2++)
    {
      digitalWrite(enPin, LOW);
      digitalWrite(dirPin, HIGH); // Enables the motor to move in a particular direction
      digitalWrite(stepPin, HIGH);
      delayMicroseconds(x3);
      digitalWrite(stepPin, LOW);
      delayMicroseconds(x3);
      digitalWrite(enPin, HIGH);
      delay(500);
      if (rotary.check(HIGH))
      {
        while (rotary.check(HIGH));   // Wait till button release
        Serial.println(" Pausado...");
        digitalWrite(d_Pin, HIGH);
        while (!rotary.check(HIGH));  // Wait till second button press
        digitalWrite(d_Pin, LOW);
      }
      stepper.setCurrentPosition(x2);
      Posicion (); //actualizar posicion en display y terminal
    }
    Serial.println("Retroceso");
    delay(1000); // One second delay
    digitalWrite(enPin, LOW);
    while (stepper.currentPosition() != -100)
    {
      stepper.setSpeed(-200);
      //stepper.runSpeed();
      stepper.run();
    }
    digitalWrite(enPin, HIGH);
    stepper.setCurrentPosition(0);
  }
  //
  // Desactivamos..
  digitalWrite(enPin, HIGH);
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  Serial.println(" Fin Pba.. ");
  delay(1000);
}

void Prueba_Cod1 () {
  // Prueba motor OK, va al final , a la vuelta para 1 seg en el medio.
  Serial.println(" ");
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  delay(1000);
  Serial.println(" Inicio Pba... ");
  digitalWrite(enPin, LOW);
  stepper.runToNewPosition(recorrido);
  digitalWrite(enPin, HIGH);
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  delay(1000);
  digitalWrite(enPin, LOW);
  stepper.runToNewPosition(135);
  digitalWrite(enPin, HIGH);
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  delay(1000);
  digitalWrite(enPin, LOW);
  stepper.runToNewPosition(0);
  digitalWrite(enPin, HIGH);
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  Serial.println(" Fin Pba.. ");
  delay(1000);
}

void Prueba_Cod2 () {
  // Prueba motor . NO /MAL (Bounce.pde)
  // Make a single stepper bounce from one limit to another
  Serial.println(" ");
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  delay(1000);
  Serial.println(" Inicio Pba... ");
  digitalWrite(enPin, LOW);
  stepper.moveTo(recorrido);
  // If at the end of travel go to the other end
  if (stepper.distanceToGo() == 0)
    stepper.moveTo(-stepper.currentPosition());
  stepper.run();
  digitalWrite(enPin, HIGH);
  //stepper.moveTo(0);
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  Serial.println(" Fin Pba.. ");
  delay(1000);
}

void Prueba_Cod3 () {
  // Prueba motor . Overshoot.pde
  Serial.println(" ");
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  delay(1000);
  Serial.println(" Inicio Pba... ");
  digitalWrite(enPin, LOW);
  // Activamos...
  //
  stepper.moveTo(recorrido);
  while (stepper.currentPosition() != 135) // Full speed up to 135
    stepper.run();
  stepper.runToNewPosition(0); // Cause an overshoot then back to 0
  //
  // Desactivamos..
  digitalWrite(enPin, HIGH);
  Serial.print("stp: ");
  Serial.println(stepper.currentPosition());
  Serial.println(" Fin Pba.. ");
  delay(1000);
}
